
extern int length = 10000;   // The amount of bars sent to be processed
string nameData,symbol;
extern string symbols = "EURUSD,GBPUSD,USDJPY";
extern string timeframe = "1,5,15,30,60,240,1440";
int TF;

int start()
{
   int sym_count = count(symbols,",");
   int per_count = count(timeframe,",");
   string symb_array[];
   string timeframe_array[];
   ArrayResize(symb_array,sym_count);
   ArrayResize(timeframe_array,per_count);
   split(symbols,symb_array);
   split(timeframe,timeframe_array);
   int old_bars;   // remember the amount of bars already known   
   
   while(!IsStopped())
   {   
      Print("Started");
      for(int i=0;i<sym_count;i++)
      {
            for(int j=0;j<per_count;j++)
            {
               int newtick=GetTickCount();   
               nameData = symb_array[i]+timeframe_array[j]+".csv";         // name of the data file to be sent
               symbol = symb_array[i];
               TF = StrToInteger(timeframe_array[j]);
               if(iBars(symb_array[i],StrToInteger(timeframe_array[j]))==0)
                  continue;
               if(!GlobalVariableCheck(symb_array[i]+timeframe_array[j]+"bars"))
                  GlobalVariableSet(symb_array[i]+timeframe_array[j]+"bars",0);
               if (GlobalVariableGet(symb_array[i]+timeframe_array[j]+"bars") != iBars(symb_array[i],StrToInteger(timeframe_array[j]))-1)      // if a new bar is received 
               {
                    int handle = FileOpen(nameData, FILE_CSV|FILE_READ,';');
                    if(handle<0)
                        createFile();
                    else
                    {
                        FileClose(handle);
         
                        handle = FileOpen(nameData, FILE_CSV|FILE_READ|FILE_WRITE,';');
                        int count=0;
                        int size = 500;
                        if(size>FileSize(handle))
                           size = FileSize(handle);
                        if(!FileSeek(handle,size*(-1),SEEK_END))
                           Print("Error "+GetLastError());
                        while(!FileIsEnding(handle))
                        {
                           FileReadString(handle);
                           if(FileIsLineEnding(handle))
                              count++;
                        }
                        FileSeek(handle,size*(-1),SEEK_END);
                        int recount = 0;
                        while(!FileIsEnding(handle))
                        {
                            FileReadString(handle);
                            if(FileIsLineEnding(handle))
                            {
                               recount++;
                               if(recount==count-2)
                               {
                                 string lastdate = FileReadString(handle);
                                 string lasttime = FileReadString(handle)+" "+lastdate;
                                 datetime lastline = StrToTime(lasttime);
                                 FileSeek(handle,0,SEEK_END);
                                 if(iBarShift(symbol,TF,lastline)>1)
                                 {
                                    int barShift = iBarShift(symbol,TF,lastline);
                                    if(barShift>2)
                                       Print("Updating "+(barShift-1)+" missed "+symbol+"'s bars");
                                    while(barShift>2)
                                    {
                                       int error = GetLastError();
                                       FileWrite(handle, TimeToStr(iTime(symbol,TF,barShift), TIME_DATE), TimeToStr(iTime(symbol,TF,barShift), TIME_SECONDS), iHigh(symbol,TF,barShift), iLow(symbol,TF,barShift), iClose(symbol,TF,barShift), iOpen(symbol,TF,barShift), iVolume(symbol,TF,barShift));
                                       barShift--;
                                    }
                                 }
                                 //Print("Last time: "+TimeToStr(iTime(symbol,TF,1), TIME_DATE)+" "+symbol+TF+" "+GlobalVariableGet(symb_array[i]+timeframe_array[j]+"bars") +" "+ (iBars(symb_array[i],StrToInteger(timeframe_array[j]))-1));
                                 if(lastline!=iTime(symbol,TF,1))
                                 {
                                    //Print("Number of ticks since start = "+(GetTickCount()-newtick));
                                    Print("Updating "+symbol+" on the "+TF+" minute timeframe"+" "+TimeToStr(iTime(symbol,TF,1), TIME_SECONDS)+" "+TimeToStr(lastline, TIME_DATE)+" "+lasttime); 
                                    FileWrite(handle, TimeToStr(iTime(symbol,TF,1), TIME_DATE), TimeToStr(iTime(symbol,TF,1), TIME_SECONDS), iHigh(symbol,TF,1), iLow(symbol,TF,1), iClose(symbol,TF,1), iOpen(symbol,TF,1), iVolume(symbol,TF,1));
                                 }
                                 break;
                               }
                            }
                         }//end of while(!FileIsEnding(handle))       
                         FileClose(handle);                            
                         Sleep(50);
                     }//end of else
                }//end of if(GlobalVariabeGet...)                              
                GlobalVariableSet(symb_array[i]+timeframe_array[j]+"bars",iBars(symb_array[i],StrToInteger(timeframe_array[j]))-1);              // remember how many bars are known      
          } //end of for(int j =0...)
      }// end of for(int i=0...)      
      int tickcount;
      tickcount = TimeSeconds(TimeCurrent());
      /*if(tickcount<35)tickcount = 35-tickcount;else*/ tickcount = 90-tickcount;
      Print("To sleep for "+tickcount+" seconds");
      Sleep(tickcount*1000);
      
   } // end of while(IsStopped())
   
   for(i=0;i<sym_count;i++)
   {
      for(j=0;j<per_count;j++)
      {
         GlobalVariableDel(symb_array[i]+timeframe_array[j]+"bars");
      }
   }
   return(0);
}

void createFile()
{
    int handle = FileOpen(nameData, FILE_CSV|FILE_WRITE,';');
    if(handle < 1)
    {
      Print("Creation of "+nameData+" failed. Error #", GetLastError());
      return(0);
    }
    FileWrite(handle, ServerAddress(), symbol, TF);                  // heading
    FileWrite(handle, "DATE","TIME","HIGH","LOW","CLOSE","OPEN","VOLUME");   // heading
    int i;
    for (i=length-1; i>=0; i--)
    {
      if(i>iBars(symbol,TF)-1)
        continue;
      FileWrite(handle, TimeToStr(iTime(symbol,TF,i), TIME_DATE), TimeToStr(iTime(symbol,TF,i), TIME_SECONDS),iHigh(symbol,TF,i), iLow(symbol,TF,i), iClose(symbol,TF,i), iOpen(symbol,TF,i), iVolume(symbol,TF,i));
    }
    FileClose(handle);
    Print("File "+nameData+" has been created. "+TimeToStr(TimeCurrent(), TIME_SECONDS) );
}

int count(string str, string delimiter)
{
  int i = 0;
  int pos = StringFind(str, delimiter);
  while(pos != -1)
  {
     i++;
     str = StringSubstr(str, pos+StringLen(delimiter));
     pos = StringFind(str, delimiter);
     if(pos == -1) break;
  }
   return(i+1);
}

int split(string str, string& arr[], string delimiter=",")
{
   int i = 0;
   int pos = StringFind(str, delimiter);
   while(pos != -1)
   {
      arr[i] = StringSubstr(str, 0, pos);
      i++;
      str = StringSubstr(str, pos+StringLen(delimiter));
      
      pos = StringFind(str, delimiter);
      if(pos == -1 || str == "") break;
   }
   arr[i] = str;
   return(0);
}